'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _reactAddons = require('react/addons');

var _reactAddons2 = _interopRequireDefault(_reactAddons);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var Test = _reactAddons2['default'].addons.TestUtils;
var click;
var ele;
var node;
var control;
var Component;
var correctMarkup;
var correctMarkupWithDefaults;

var testCorrectMarkup = function testCorrectMarkup(props, childs) {
    return function () {

        expect(_reactAddons2['default'].renderToStaticMarkup(_reactAddons2['default'].createElement(Component, props, childs || null))).toBe(correctMarkup);
    };
};

var testCorrectMarkupWithDefaults = function testCorrectMarkupWithDefaults(props, childs) {
    return function () {
        expect(_reactAddons2['default'].renderToStaticMarkup(_reactAddons2['default'].createElement(Component, props, childs || null))).toBe(correctMarkupWithDefaults);
    };
};

beforeEach(function () {
    click = jest.genMockFunction();
});

describe('Button', function () {

    beforeEach(function () {
        Component = _Button2['default'];
        correctMarkup = '';
        correctMarkupWithDefaults = '';
    });

    describe('Button#render', function () {

        beforeEach(function () {
            correctMarkup = '<button name="name" title="Button Title" class="btn btn-danger">A Button</button>';
        });

        it('it should render the correct markup', testCorrectMarkup({
            name: "name",
            title: 'Button Title',
            className: 'btn btn-danger',
            onClick: click
        }, 'A Button'));
    });
});