import React from 'react';
import util from '../util'
import Anchor from './Anchor';

/**
 * Button provides a clickable button.
 */
class Button extends React.Component {

    clicked(e){
        this.props.set(this.props.name, e.target.value);
    }

    render() {

        var props = {};

        for(var key in this.props)
            if(this.props.hasOwnProperty(key))
                props[key] = this.props[key];

        if(this.props.set)
            props.onClick = this.clicked.bind(this);

        return util.skipKeys('button', props, this.props.children);

    }


}

Button.propTypes = {
    name: React.PropTypes.string.isRequired,
    onClick: React.PropTypes.func,
    set: React.PropTypes.func,
    className: React.PropTypes.string
};

export default Button;
