import React from 'react';
import Radio from './Radio';

/**
 * CheckBox
 */
class CheckBox extends Radio {

    constructor(props) {
        super(props);
        this.state = {checkedValue: this.props.checkedValue};
        this.NATIVE_TYPE = 'checkbox';
        this.INLINE_CLASS = 'checkbox-inline'
    }

    changed() {

        var {checked, checkedValue} = this.props;
        var value = !checked;

        if (checkedValue)
            value = (value) ? checkedValue : undefined;

        this.props.set(this.props.name, value);
    }

}

CheckBox.propTypes = {
    type: React.PropTypes.string,
    name: React.PropTypes.string.isRequired,
    className: React.PropTypes.string,
    checked: React.PropTypes.bool,
    checkedValue: React.PropTypes.any,
    inline: React.PropTypes.bool,
    set: React.PropTypes.func,
    onChange: React.PropTypes.func,
    onBlur: React.PropTypes.func,
    onFocus: React.PropTypes.func
};

export default CheckBox
