import React from 'react/addons';
import Button from '../Button';

var Test = React.addons.TestUtils;
var click;
var ele;
var node;
var control;
var Component;
var correctMarkup;
var correctMarkupWithDefaults;

var testCorrectMarkup = function (props, childs) {
    return function () {

        expect(React.renderToStaticMarkup(
            React.createElement(Component, props, childs || null))).
            toBe(correctMarkup);
    }

};

var testCorrectMarkupWithDefaults = function (props, childs) {
    return function () {
        expect(React.renderToStaticMarkup(
            React.createElement(Component, props, childs || null))).
            toBe(correctMarkupWithDefaults);
    }
};


beforeEach(function () {
    click = jest.genMockFunction();
});

describe('Button', function () {

    beforeEach(function () {
        Component = Button;
        correctMarkup = '';
        correctMarkupWithDefaults = '';
    });

    describe('Button#render', function () {

        beforeEach(function () {
            correctMarkup = '<button name="name" title="Button Title" class="btn btn-danger">A Button</button>';
        });

        it('it should render the correct markup',
            testCorrectMarkup({
                name: "name",
                title: 'Button Title',
                className: 'btn btn-danger',
                onClick: click
            }, 'A Button'));
    });
});



