import form from './form';
import view from './view';
import ReactType from './react/ReactType';
import Loader from './react/Loader';

var types = {

    'nav-link': new ReactType(form.NavLink),
    link: new ReactType(form.Anchor),
    button: new ReactType(form.Button),
    'button-group': new ReactType(form.ButtonGroup),
    'button-dropdown': new ReactType(form.ButtonDropDown),
    'dropdown-header': new ReactType(form.DropDownHeader),
    'dropdown-divider': new ReactType(form.DropDownDivider),
    'dropdown-item': new ReactType(form.DropDownItem),
    form: new ReactType(form.Form),
    input: new ReactType(form.Input),
    text: new ReactType(form.Input),
    radio: new ReactType(form.Radio),
    checkbox: new ReactType(form.CheckBox),
    select: new ReactType(form.Select),
    textarea: new ReactType(form.TextArea),
    'stacked-radio': new ReactType(form.StackedCheckBox),
    'stacked-checkbox': new ReactType(form.StackedCheckBox),
    'horizontal-control': new ReactType(form.HorizontalControl),
    'horizontal-group': new ReactType(form.HorizontalGroup),
    'horizontal-input': new ReactType(form.HorizontalInput),
    'horizontal-text': new ReactType(form.HorizontalInput),
    'horizontal-select': new ReactType(form.HorizontalSelect),
    'horizontal-textarea': new ReactType(form.HorizontalTextArea),
    'vertical-input': new ReactType(form.VerticalInput),
    'vertical-text': new ReactType(form.VerticalInput),
    'vertical-select': new ReactType(form.VerticalSelect),
    'vertical-textarea': new ReactType(form.VerticalTextArea),
    panel: new ReactType(view.Panel),
    'panel-heading': new ReactType(view.PanelHeading),
    'panel-body': new ReactType(view.PanelBody),
    'panel-footer': new ReactType(view.PanelFooter),
    column: new ReactType(view.Column),
    row: new ReactType(view.Row),
    dl: new ReactType(view.DefinitionList),
    view: new ReactType(view.View),
    table: new ReactType(view.Table),
    container: new ReactType(view.Container),
    tab: new ReactType(view.Tab),
    'nav-list': new ReactType(view.NavList),
    'html': new ReactType(view.HTMLElement),
    'breadcrumb': new ReactType(view.BreadCrumb),
    'list-item': new ReactType(view.ListItem),
    icon: new ReactType(view.IconFont),
    'loader': new ReactType(Loader)
};

var ex = {
    types: types,
    ReactType: ReactType,
    install: function (env) {
        for (var key in types)
            if (types.hasOwnProperty(key))
                env.addType(key, types[key])
    }
};
export default ex
